#include <stdio.h>
#include <stdlib.h>

typedef void* Object;

typedef enum {false,true} boolean;

void swap(Object* xs,int i,int j){
  Object tmp=xs[i];
  xs[i]=xs[j];
  xs[j]=tmp;
}

boolean bubble(Object* xs,int i,boolean smaller(Object,Object)){
  boolean result = false;
  int j=0;
  for (;j<(i-1);j++)
    if (!smaller(xs[j],xs[j+1])){
      swap(xs,j,j+1);
      result=true;
    }
  return result;
}

void bubbleSort(Object* xs, int length,boolean smaller(Object,Object)){
  boolean changed = true;
  for (;changed && length>1;length--) 
    changed=bubble(xs,length,smaller);
}

void printArray(Object* xs,int length,void printer(Object)){
  int i=0;
  printf("[");
  for (;i<length;i++){
    printer(xs[i]);
    if (i<length-1) printf(", ");
  }
  printf("]\n");
}

typedef struct {
  int x;
  int y;
} PunktStrukt;

typedef PunktStrukt* Punkt;

Punkt newPunkt(int x,int y){
  Punkt this = (Punkt)malloc(sizeof(PunktStrukt));
  this->x=x; 
  this->y=y;
  return this;
} 

void deletePunkt(Punkt this){
  free(this);
}

int square(int x){return x*x;}
int betragQuadrat(Punkt p){return square(p->x)+square(p->y);}


boolean lePunkt(Object o1,Object o2){
  Punkt p1=(Punkt)o1;
  Punkt p2=(Punkt)o2;
  return betragQuadrat(p1)<betragQuadrat(p2);
}

void printPunkt(Object p){
  printf("(%i,%i)",((Punkt)p)->x,((Punkt)p)->y);
}

typedef int* Integer;

Integer newInt(int x){
  Integer result =(void*)malloc(sizeof(int));
  *result=x;
  return result;
}

void deleteInt(Integer this){free(this);}

void printInt(Object p){printf("%i",*((Integer)p));}

boolean leInt(Object o1,Object o2){
  Integer i1=(Integer)o1;
  Integer i2=(Integer)o2;
  return *i1<*i2;
}

typedef boolean* Boolean;

Boolean newBoolean(boolean x){
  Boolean result =(Boolean)malloc(sizeof(boolean));
  *result = x;
  return result;
}

void printBoolean(Object p){
  if (*((Boolean)p)) printf("true");
  else printf("false");
}

boolean leBoolean(Object o1,Object o2){return *(Boolean)o1;}

int main(){
  Punkt xs [] = {newPunkt(321,43)
                ,newPunkt(43,5345)
                ,newPunkt(54,543)
                ,newPunkt(543,543)
                ,newPunkt(43,1)
                ,newPunkt(4,2)};
  bubbleSort((Object*)xs,6,lePunkt);
  printArray((Object*)xs,6,printPunkt);
  int i=0;
  for (;i<6;i++) deletePunkt(xs[i]);

  Object ys [6];
  for (i=0;i<6;i++)ys[i]=newInt(42-i);
  
  bubbleSort(ys,6,leInt);
  printArray(ys,6,printInt);
  for (i=0;i<6;i++) deleteInt(ys[i]);

  for (i=0;i<6;i++) ys[i]=((Object)newBoolean(i%3==0));
  bubbleSort(ys,6,leBoolean);
  printArray(ys,6,printBoolean);

  return 0;
}

