#include "Complex.h"
#include <stdio.h>

void printComplex(Complex c){
  printf("(%f,%f)",c.real,c.imag);
}

Complex add(Complex x,Complex y){
  Complex result = {x.real+y.real,x.imag+y.imag};
  return result;
}
Complex sub(Complex x,Complex y){
  Complex result = {x.real-y.real,x.imag-y.imag};
  return result;
}
Complex mult(Complex x,Complex y){
  Complex result = {x.real*y.real-x.imag*y.imag
                   ,x.real*y.imag+x.imag*y.real};
  return result;
}
Complex divC(Complex x,Complex y){
  Complex result = { (x.real*y.real+x.imag*y.imag)
                    /(y.imag*y.imag+y.real*y.real)
                   , (x.imag*y.real-x.real*y.imag)
                    /(y.imag*y.imag+y.real*y.real)};
  return result;
}

double norm(Complex x){
  return x.real*x.real+x.imag*x.imag;
}
unsigned int schwelle(Complex c,double schwellwert){
  unsigned int result = 0;
  Complex z = {0,0};
  while(!(norm(z)> schwellwert) && result<50){
    z=add(mult(z,z),c);
    result=result+1;
  }
  return result;
}

Complex mapComplex(Complex c,double f(double x)){
  Complex result={f(c.real),f(c.imag)};
  return result;
}


