#include "ListUtil.h"

int length(List xs){
  if (isEmpty(xs)) return 0;
  return 1+length(xs->tail);
}

int lengthIteration(List xs){
  int result=0;
  while (!isEmpty(xs)){
    result=result+1;
    xs=xs->tail;
  }
  return result;
}

int sumRecursion(List xs){
  if (isEmpty(xs)) return 0;
  return xs->head+length(xs->tail);
}

int sum(List xs){
  int result=0;
  while (!isEmpty(xs)){
    result=result+xs->head;
    xs=xs->tail;
  }
  return result;
}

double avg(List xs){
  if (isEmpty(xs)) return 0;
  double su = sum(xs);
  double le = length(xs);
  return su/le;
}

int last(List xs){
  if (isEmpty(xs)) return 0;
  if (isEmpty(xs->tail)) return xs->head;
  return last(xs->tail);
}

List reverseRecursive(List xs){
  if (isEmpty(xs)) return nil();
  return append(reverse(xs->tail),cons(xs->head,nil()));
}

List reverse(List xs){
  List result=nil();
  while (!isEmpty(xs)){
    result=cons(xs->head,result);
    xs=xs->tail;
  }
  return result;
}

List copy(List xs){
  if (isEmpty(xs)) return nil();
  return cons(xs->head,copy(xs->tail));
}

List append(List xs,List ys){
  if (isEmpty(xs)) return copy(ys);
  return cons(xs->head,append(xs->tail,ys));
}

List map(int f (int),List xs){
  if (isEmpty(xs)) return nil();
  return cons(f(xs->head),map(f,xs->tail));
}


